# include <stdlib.h>
# include "list.h"

# ifdef __GNUC__
inline
# endif
Link *
AllocLink(void *elt)
{
	Link *link = (Link *)malloc(sizeof(Link));
	link->elt = elt;
	return link;
}

# ifdef __GNUC__
inline
# endif
void
FreeLink(Link *link)
{
	free(link);
}

void
Insert(List *list, void *elt)
{
	Link *newNode = AllocLink(elt);
	newNode->next = list->head;
	list->head = newNode;
	if (list->tail == NULL)
		list->tail = newNode;
}

void
Append(List *list, void *elt)
{
	Link *newNode = AllocLink(elt);
	newNode->next = NULL;
	if (list->tail == NULL)
		list->tail = list->head = newNode;
	else {
		list->tail->next = newNode;
		list->tail = newNode;
	}
}

void
FreeList(List *list)
{
	Link *link = list->head;
	Link *next;
	while (link != NULL) {
		next = link->next;
		FreeLink(link);
		link = next;
	}
}

void *
RemoveHead(List *list)
{
	if (list->head == NULL)
		return NULL;

	{
		void *elt = list->head->elt;
		Link *tmp = list->head->next;
		FreeLink(list->head);
		list->head = tmp;
		if (list->head == NULL)
			list->tail = NULL;
		return elt;
	}
}
