# include <stdio.h>

typedef struct StatInfo StatInfo;

struct StatInfo {
	char     *fileName;
	char     *fnName;
	short     numCounters;
	long     *counters;
	StatInfo *next;
};

StatInfo  dummy = {"", "", 0, NULL, NULL};
StatInfo *head = &dummy;
StatInfo *tail = &dummy;
long	  memUsed = 0;

char  *SSS_fileName;
char  *SSS_fnName;
short  SSS_numCounters;
long  *SSS_counters;

void
RegisterCounters()
{
	int       n;
	StatInfo *newOne;

	newOne = (StatInfo *)malloc(sizeof(StatInfo));
	memUsed += sizeof(StatInfo);
	newOne->next = NULL;

	n = strlen(SSS_fileName) + 1;
	memUsed += n;
	newOne->fileName = (char *)malloc(n);
	strcpy(newOne->fileName, SSS_fileName);

	n = strlen(SSS_fnName) + 1;
	memUsed += n;
	newOne->fnName = (char *)malloc(n);
	strcpy(newOne->fnName, SSS_fnName);

	newOne->numCounters = SSS_numCounters;
	newOne->counters = SSS_counters;
	memUsed += (SSS_numCounters * sizeof(long));

	tail->next = newOne;
	tail = newOne;
}

void
OutputStatsAndFreeMem()
{
	int       i;
	StatInfo *next;
	StatInfo *tmp = head->next;
	FILE     *fp = fopen("bb.out", "w");

	if (fp == NULL) {
		fprintf(stderr, "Unable to open \'bb.out\' for writing\n");
		fprintf(stderr, "Using <stdout>\n");
		fp = stdout;
	}

	while (tmp != NULL) {
		fprintf(fp, "%s %s %d\n", tmp->fileName, tmp->fnName, tmp->numCounters);
		for (i = 0; i < tmp->numCounters; i++)
			fprintf(fp, "%ld ", tmp->counters[i]);
		fprintf(fp, "\n");

		next = tmp->next;

		free(tmp->fileName);
		free(tmp->fnName);
		free(tmp);

		tmp = next;
	}

	fclose(fp);
	fprintf(stderr, "Mem used in profiling - %ld\n", memUsed);
}
